package com.zksy.data.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zksy.common.exception.DbException;
import com.zksy.data.annotation.XhDataLogRecord;
import com.zksy.data.domain.po.XcrOtherInfo37;
import com.zksy.data.domain.response.XcrOtherInfo37Response;
import com.zksy.data.mapper.XcrOtherInfo37Mapper;
import com.zksy.data.service.XcrOtherInfo37Service;
import com.zksy.data.utils.RedisService;
import com.zksy.data.utils.XhRequestUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.support.TransactionTemplate;

import java.util.HashMap;
import java.util.List;
import java.util.Vector;

/**
* @author Administrator
* @description 针对表【xcr_other_info_37(燃气费清单表)】的数据库操作Service实现
* @createDate 2024-10-15 10:27:51
*/
@Service
@Slf4j
public class XcrOtherInfo37ServiceImpl extends ServiceImpl<XcrOtherInfo37Mapper, XcrOtherInfo37>
    implements XcrOtherInfo37Service{
    @Autowired
    private XhRequestUtil xhRequestUtil;
    @Autowired
    private RedisService redisService;
    @Autowired
    private TransactionTemplate transactionTemplate;
    @Override

    @XhDataLogRecord("同步燃气费清单表信息")
    public void saveDataByUniCode(String address) {
        //模拟从数据库中取数据大约为3000-4000条
        List<String> creditCodes = (List<String>) redisService.getList("creditCodes").get(0);
        Vector<XcrOtherInfo37> toDatabaseList = new Vector<>();
        List<String> inventoryList = List.of("37");
        inventoryList.parallelStream().forEach(inventory -> {
            creditCodes.parallelStream().forEach(creditCode -> {
                HashMap<String, String> requestbodyMap = new HashMap<>();
                requestbodyMap.put("entityCode", creditCode);
                requestbodyMap.put("size", String.valueOf(10));
                requestbodyMap.put("page", String.valueOf(1));
                requestbodyMap.put("inventoryId", inventory);
                try {
                    List<XcrOtherInfo37> list = xhRequestUtil.requestXinyonghuanhuai2(requestbodyMap,address,
                            XcrOtherInfo37Response.class,
                            XcrOtherInfo37.class);
                    if(list != null){
                        toDatabaseList.addAll(list);
                    }
                } catch (Exception e) {
                    List<XcrOtherInfo37> list = xhRequestUtil.requestXinyonghuanhuai2(requestbodyMap,address,
                            XcrOtherInfo37Response.class,
                            XcrOtherInfo37.class);
                    if(list != null){
                        toDatabaseList.addAll(list);
                    }
                }
            });
            log.info("inventorywe为:{}完成",inventory);
        });
        transactionTemplate.execute((s)->{
            try {
                this.remove(null);
                this.saveBatch(toDatabaseList);
            } catch (Exception e) {
                s.setRollbackOnly();
                throw new DbException(e);
            }
            return null;
        });
        log.info("燃气费清单表同步完成");
    }
}




